@echo off
:
: Version for Serviio 1.0 or greater
:
: To intercept Serviio FFmpeg Calls install this bat as "C:\Program Files\Serviio\lib\ffmpeg.bat"
: then Edit "C:\Program Files\Serviio\bin\ServiioService.exe.vmoptions" 
: and change the contents to:
: -Xmx512m
: -Dffmpeg.location="C:\Program Files\Serviio\lib\ffmpeg.bat"
:
: Finally install 32 bit curl.exe in C:\windows\system32 or the 64 bit version in C:\windows\sysWOW64
:
: HOW TO USE THIS BAT
: -------------------
: The RefreshWebResources.groovy uses this bat as is to allow refresh of any WebResource "feed".
:
: Other WebResource groovys may exploit this bat by:
:
: 1) Getting the repository "id" nnn for the library to be refreshed
: either from a static setting, a WebResource URL parameter eg: url?id=nn, or preferably
: by Using curl -X GET "http://localhost:23423/rest/repository" and extracting the id matching the URL.
:
: 2) Having the web resource use that "id" when creating in a refresh-on-demand item as the v value nnn in the url
: rtsp://a1709.l1856953708.c18569.g.lm.akamaistream.net:554/D/1709/18569/vnnn/reflector:53708
:
: This bat will then extract the v value when the refresh-on-demand icon is clicked and call curl to refresh that id.
:
: For example the web resource hahasport.groovy calls a predefined method to extract the id mmm from the online library entry 
: that matches the calling url "http://www.hahasport.com/c-n.html" 
: and uses it in the link rtsp://a1709.l1856953708.c18569.g.lm.akamaistream.net:554/D/1709/18569/vmmm/reflector:53708
: when creating the "Force Refresh" item. When the item is clicked, the following code will be executed 
: and library mmm will be refreshed before passing control back to Serviio's ffmpeg with the original ffmpeg parameters.


: Setup %TIME% so we can display a time stamp in log entry
VER | TIME > TEMP.BAT
ECHO SET TIME=%%3>CURRENT.BAT
CALL TEMP.BAT 2> nul
DEL TEMP.BAT
DEL CURRENT.BAT

: Detect empty call to ffmpeg which Serviio issues at restart to ensure ffmpeg is present and just pass to ffmpeg
if .%1==. goto noarg

: The ffmpeg call has the form  "ffmpeg command" -i "url" parm parm .... parm
: or "ffmpeg command" -rtsp_transport +http+tcp+udp -i  "url" parm parm .... parm
: Keep the ffmpeg parameters up to -i in A1, A2 and A3 and B=url and put the rest in a string called REST.
set A1=%1
if %A1% == -i goto geturl
shift
set A2=%1
if %A1% == -i goto geturl
shift
set A3=%1
if %A1% == -i goto geturl

:geturl
shift
set B=%1
if .%B%==. goto noarg
shift
set REST=%1

echo A1=%A1% A2=%A2% A3=%A3% 
echo B=%B%
echo REST=%REST%

: Process the "parms" to find any "scale" parameter which would have been split into 2 by the = sign and rebuild it.
:loop 
shift 
if [%1]==[] goto endloop
rem if a parameter is "scale" skip it and prefix the next parameter with "scale="
rem this addresses the transcoding for the mediabrowser which includes a scale=h:w parameter.
if not [%1]==[scale] goto notscale
shift
set REST=%REST% scale=%1
goto loop
:notscale
set REST=%REST% %1
goto loop 
:endloop 

: extract the v value nnn from any url matching: 
: rtsp://a1709.l1856953708.c18569.g.lm.akamaistream.net:554/D/1709/18569/vnnn/reflector:53708
: Note: if no v value nnn is found vval will contain the original url rather than nnn
set vval=%B%
: truncate following nnn
set vval=%vval:/reflector:53708=%
: extract value following v 
set vval=%vval:rtsp://a1709.l1856953708.c18569.g.lm.akamaistream.net:554/D/1709/18569/v=%

: detect special 0 v values which allow memo feed items to be created that do not refresh
: if vval is 0 it is a Memo icon that does not refresh - restore the original url to avoid refresh
if .%vval%==.0 set vval=%B%
if .%vval%==.00 set vval=%B%

: refresh id nnn if v value found
if not .%vval%==.%B% curl -X POST "http://localhost:23423/rest/action" -H "Content-Type: text/xml" -d "<action><name>forceOnlineResourceRefresh</name><parameter>%vval%</parameter></action>"

: log all REFRESHES and all SERVIIO ffmpeg calls to "C:\Program Files\Serviio\log\ffmpeg.log"
: Insert a : at start of next 2 lines to turn off logging.
if not .%vval%==.%B% echo REFRESH ID %vval% >> "C:\Program Files\Serviio\log\ffmpeg.log"
echo %TIME% "C:\Program Files\Serviio\lib\ffmpeg.exe" %A1% %A2% %A3% %B% %REST% >> "C:\Program Files\Serviio\log\ffmpeg.log"

:noarg
: issue the original ffmpeg command
"C:\Program Files\Serviio\lib\ffmpeg.exe" %A1% %A2% %A3% %B% %REST% 

exit